﻿Public Class frmGauss

    Shared Wert1 As Single
    Shared iZ As Integer
    Shared Vektor As New Collection()
    Const Pfad = "C:\Benutzer\Bernd\Programme\WIT_VB_2010\Zerl3\"
    Shared blnSicher As Boolean

    Private Sub frmGauss_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim Ausgabe As String

        With Me
            .WindowState = 2
            .Text = "Programm  " + strPgmName + ", Version " + strVersion

            .GroupBox1.Text = "Allgemeines "
            .GroupBox2.Text = "Eingaben "
            .GroupBox3.Text = "Ergebnisse "
            .GroupBox4.Text = "Kontrolle "
            .GroupBox1.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Red)
            .GroupBox2.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Red)
            .GroupBox3.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Red)
            .GroupBox4.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Red)

            .Button1.Text = "Berechnen"
            .Button1.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .Button2.Text = "A * x - B ="
            .Button2.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .Button3.Text = "A symmetrisch"
            .Button3.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .Button4.Text = "Eingabezeile übernehmen"
            .Button4.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)

            Call Vorbelegung()

            Ausgabe = "Lösung von linearen Gleichungssystemen nach Gauss" + vbCrLf
            Ausgabe = Ausgabe + "mit mehrfachen rechten Seiten"
            .Label1.Text = Ausgabe
            .Label1.Font = New Font("arial", 14, FontStyle.Bold, ForeColor = Color.Black)
            Ausgabe = "(Voraussetzung: Hauptdiagonalelemente a(i,i) <> 0" + vbCrLf
            Ausgabe = Ausgabe + "falls nicht erfüllt: Reihenfolge der Gleichungen ändern!)"
            .Label9.Text = Ausgabe
            .Label9.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)

            'Einheiten
            .Label2.Text = "Projekt"
            .Label3.text = "Position"
            .TextBox1.Text = strProjekt
            .TextBox2.Text = strPosition

            'Eingaben
            .Label4.Text = "Anzahl der Gleichungen " + vbCrLf + "und Unbekannten N ="
            .Label4.Font = New Font("arial", 10, FontStyle.Regular, ForeColor = Color.Black)
            .TextBox3.Text = Str(N)
            .Label8.Text = "(Bei Neueingabe von N wird das Gleichungssystem gelöscht!)"
            .Label8.Font = New Font("arial", 10, FontStyle.Regular, ForeColor = Color.Black)

            .Label5.Text = "Koeffizientenmatrix A"
            .Label5.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .Label6.Text = "rechte Seite B"
            .Label6.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .Label7.Text = "* x ="
            .Label7.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .Label10.Text = "Lösungen x"
            .Label10.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .Label11.Text = "Nullvektor"
            .Label11.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .Label12.Text = "Eingabe-" + vbCrLf + "zeile:"
            .Label12.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)

            Call showlistView_A(A)
            Call showlistView_B(B)
            .ListView3.Height = 30 + 20 * N
            .ListView4.Height = 30 + 20 * N

            iZ = 1
            .TextBox4.Text = Str(iZ)
            Call EingabezeileBelegen()
            Call TextBoxUnsichtbar()
        End With
    End Sub

    Public Sub EingabezeileBelegen()
        TextBox5.Text = Str(A(iZ, 1))
        TextBox6.Text = Str(A(iZ, 2))
        TextBox7.Text = Str(A(iZ, 3))
        TextBox8.Text = Str(A(iZ, 4))
        TextBox9.Text = Str(A(iZ, 5))
        TextBox10.Text = Str(B(iZ))
    End Sub

    Private Sub TextBoxUnsichtbar()
        'Eingabezeile zuschneiden
        If N < 5 Then TextBox9.Visible = False
        If N < 4 Then TextBox8.Visible = False
        If N < 3 Then TextBox7.Visible = False
        If N < 2 Then TextBox6.Visible = False

        If N > 1 Then TextBox6.Visible = True
        If N > 2 Then TextBox7.Visible = True
        If N > 3 Then TextBox8.Visible = True
        If N > 4 Then TextBox9.Visible = True
    End Sub

    Private Sub showlistView_A(ByVal X(,) As Double)
        Dim i As Integer, j As Integer
        With ListView1
            .View = View.Details
            .GridLines = True
            .Width = 35 + N * 50
            .Height = 30 + N * 20
            .Clear()
            .Columns.Add("", 30, HorizontalAlignment.Right)                '1. Spalte, 30 Pixel
            For j = 1 To N
                .Columns.Add(j.ToString, 50, HorizontalAlignment.Center)   'Kopfzeile
            Next j
            For i = 1 To N
                Dim Item As New ListViewItem(i.ToString)
                For j = 1 To N
                    Item.SubItems.Add(X(i, j).ToString("0.00"))
                Next j
                .Items.Add(Item)
            Next i
        End With
    End Sub

    Private Sub showlistView_B(ByVal Y() As Double)
        Dim i As Integer
        With ListView2
            .View = View.Details
            .GridLines = True
            .Width = 85
            .Height = 30 + N * 20
            .Clear()
            .Columns.Add("", 30, HorizontalAlignment.Right)            '1. Spalte, 30 Pixel
            .Columns.Add(1.ToString, 50, HorizontalAlignment.Center)   'Kopfzeile
            For i = 1 To N
                Dim Item As New ListViewItem(i.ToString)
                Item.SubItems.Add(B(i).ToString("0.00"))
                .Items.Add(Item)
            Next i
        End With
    End Sub

    Private Sub showlistView_Z(ByVal Z() As Double)
        Dim i As Integer
        With ListView3
            .View = View.Details
            .GridLines = True
            .Width = 115
            .Height = 30 + N * 20
            .Clear()
            .Columns.Add("", 30, HorizontalAlignment.Right)            '1. Spalte, 30 Pixel
            .Columns.Add(1.ToString, 80, HorizontalAlignment.Center)   'Kopfzeile
            For i = 1 To N
                Dim Item As New ListViewItem(i.ToString)
                Item.SubItems.Add(Z(i).ToString("0.0000"))
                .Items.Add(Item)
            Next i
        End With
    End Sub

    Private Sub showlistView_K(ByVal K() As Double)
        Dim i As Integer
        With ListView4
            .View = View.Details
            .GridLines = True
            .Width = 235
            .Height = 30 + N * 20
            .Clear()
            .Columns.Add("", 30, HorizontalAlignment.Right)            '1. Spalte, 30 Pixel
            .Columns.Add(1.ToString, 200, HorizontalAlignment.Center)   'Kopfzeile
            For i = 1 To N
                Dim Item As New ListViewItem(i.ToString)
                Item.SubItems.Add(K(i).ToString("0.00000000000000000"))
                .Items.Add(Item)
            Next i
        End With
    End Sub

    Private Sub VektorDef()
        'Speichern der Matrix in einem Vektor
        Dim Zeile As String
        Dim Format As String
        Format = "0.00000  "
        Vektor.Clear()
        Zeile = ""
        For j = 1 To N
            Zeile = "a" + Str(j) + "  = "
            For i = 1 To N
                Zeile = Zeile + "  " + A(j, i).ToString(Format)
            Next i
            Vektor.Add(Zeile + " " + B(j).ToString(Format))
        Next j
        Zeile = "x = "
        For j = 1 To N
            Zeile = Zeile + "  " + X(j).ToString(Format)
        Next j
        Vektor.Add(Zeile)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Berechnung
        Dim i As Integer, j As Integer
        'Sichern der ursprünglichen Matrix A und des Vektors B
        For i = 1 To N
            For j = 1 To N
                A1(i, j) = A(i, j)
            Next j
            B1(i) = B(i)
        Next i

        Call Hauptprogramm(blnFehler)

        With Me
            For i = 1 To N
                If Not blnFehler Then
                    '.Text10(i - 1).Text = "X(" + Str(i) + ") = " + Format(X(i), "###0.000")
                Else
                    '.Text10(i - 1).Text = ""
                End If
            Next i
        End With

        'Wiederherstellung der ursprünglichen Matrix A und des Vektors B
        For i = 1 To N
            For j = 1 To N
                A(i, j) = A1(i, j)
            Next j
            B(i) = B1(i)
        Next i

        Call showlistView_Z(X)

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Kontrollen
        Dim i As Integer, k As Integer
        Dim s As Double
        For i = 1 To N
            s = 0
            For k = 1 To N
                s = s + A1(i, k) * X(k)
            Next k
            s = s - B1(i)
            Kontr(i) = s
        Next i

        Call showlistView_K(Kontr)

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'Symmetrische Felder unter der Hauptdiagonalen belegen
        Call Symmetrie()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        'Eingabezeile übernehmen
        Call showlistView_A(A)
        Call showlistView_B(B)
    End Sub

    Public Sub textbox1_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.Leave
        'Einheit Länge
        strProjekt = TextBox1.Text
    End Sub

    Public Sub textbox2_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox2.Leave
        'Einheit Länge
        strPosition = TextBox2.Text
    End Sub

    Private Sub TextBox3_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox3.TextChanged
        'Anzahl Gleichungen/Unbekannte
        Dim N1 As Integer, i As Integer, k As Integer
        With Me
            N1 = Val(.TextBox3.Text)
            If N1 > 5 Then
                MsgBox("max. Rang des Gleichungssystems: N = 5")
                N1 = 5
                .TextBox3.Text = Str(N1)
            End If
            If N1 <> N Then
                For i = 1 To N
                    For k = 1 To N
                        A(i, k) = 0
                    Next k
                    B(i) = 0
                Next i
                N = N1
            End If

            Call showlistView_A(A)
            Call showlistView_B(B)
            .ListView3.Height = 30 + 20 * N
            .ListView4.Height = 30 + 20 * N
            Call EingabezeileBelegen()
            Call TextBoxUnsichtbar()
        End With
    End Sub

    Private Sub TextBox4_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox4.TextChanged
        'Gleichungsnummer eingeben
        iZ = Val(TextBox4.Text)
        If iZ < 1 Then
            MessageBox.Show("unzulässige Eingabe")
            iZ = 1
            TextBox4.Text = iZ.ToString
        End If
        If iZ > N Then
            MessageBox.Show("max. Eingabe: " + N.ToString)
            iZ = N
            TextBox4.Text = iZ.ToString
        End If
        TextBox5.Text = Str(A(iZ, 1))
        TextBox6.Text = Str(A(iZ, 2))
        TextBox7.Text = Str(A(iZ, 3))
        TextBox8.Text = Str(A(iZ, 4))
        TextBox9.Text = Str(A(iZ, 5))
        TextBox10.Text = Str(B(iZ))
    End Sub

    Public Sub textbox5_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox5.Leave
        'Koeffizient a(iZ,1)
        A(iZ, 1) = Val(TextBox5.Text)
    End Sub

    Public Sub textbox6_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox6.Leave
        'Koeffizient a(iZ,2)
        A(iZ, 2) = Val(TextBox6.Text)
    End Sub

    Public Sub textbox7_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox7.Leave
        'Koeffizient a(iZ,3)
        A(iZ, 3) = Val(TextBox7.Text)
    End Sub

    Public Sub textbox8_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox8.Leave
        'Koeffizient a(iZ,4)
        A(iZ, 4) = Val(TextBox8.Text)
    End Sub

    Public Sub textbox9_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox9.Leave
        'Koeffizient a(iZ,5)
        A(iZ, 5) = Val(TextBox9.Text)
    End Sub

    Public Sub textbox10_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox10.Leave
        'Koeffizient b(iZ)
        B(iZ) = Val(TextBox10.Text)
    End Sub

    Private Sub EndeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EndeToolStripMenuItem.Click
        Close()
    End Sub

    Sub LoadText(ByVal Dateiname As String)
        Dim i As Integer, j As Integer
        Dim teil() As String
        Dim ap As String, bp As String
        Try
            Dim Text As String
            Vektor.Clear()
            Using Datei As IO.StreamReader = New IO.StreamReader(Dateiname)
                Do
                    Text = Datei.ReadLine()
                    Vektor.Add(Text)
                Loop Until Text Is Nothing
                Datei.Close()
            End Using
            teil = Vektor.Item(1).split(" ")

            N = 5
            For j = 0 To N - 1
                teil = Vektor.Item(j + 1).split(" ")
                For i = 1 To teil.Count - 2
                    ap = teil(i).Replace(",", ".")
                    A(j + 1, i) = Val(ap)
                Next i
                bp = teil(N + 1).Replace(",", ".")
                B(j + 1) = Val(bp)
                'Call Belegen()
            Next j

            'Felder vorbereiten und belegen
            Call showlistView_A(A)
            Call showlistView_B(B)
            ListView3.Height = 30 + 20 * N
            ListView4.Height = 30 + 20 * N
            Call EingabezeileBelegen()
            Call TextBoxUnsichtbar()
        Catch
            MsgBox("Fehler in der Sub LoadText: " + Err.Description)
        End Try
    End Sub

    Private Sub ÖffnenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ÖffnenToolStripMenuItem.Click
        OpenFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"
        OpenFileDialog1.ShowDialog()
        LoadText(OpenFileDialog1.FileName)
    End Sub

    Sub SaveText(ByVal Dateiname As String)
        Try
            Dim i As Integer
            Call VektorDef()
            Using Datei As IO.StreamWriter = New IO.StreamWriter(Dateiname)
                For i = 1 To Vektor.Count
                    Datei.WriteLine(Vektor.Item(i))
                Next
                Datei.Close()
            End Using
            blnSicher = True
        Catch
            MsgBox("Fehler in der Sub SaveText: " + Err.Description)
            blnSicher = False
        End Try
    End Sub

    Private Sub SpeichernToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernToolStripMenuItem.Click
        SaveFileDialog1.Filter = "txt files (*.txt)|*.txt"
        SaveFileDialog1.ShowDialog()
        SaveText(SaveFileDialog1.FileName)
    End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim i As Integer
        Dim Schrift1 As Font = New Font("Arial", 14, FontStyle.Bold)
        Dim Schrift2 As Font = New Font("courier new", 12, FontStyle.Regular)
        Call VektorDef()
        e.Graphics.DrawString("Programm Gauss, Version 5.0", Schrift1, Brushes.Black, 50, 40)
        e.Graphics.DrawString("N = " + N.ToString, Schrift1, Brushes.Black, 50, 70)
        For i = 1 To N
            e.Graphics.DrawString(Vektor.Item(i), Schrift2, Brushes.Black, 50, 80 + 20 * i)
        Next i
        e.Graphics.DrawString("*** Ergebnis", Schrift1, Brushes.Black, 50, 110 + 20 * N)
        e.Graphics.DrawString(Vektor.Item(N + 1), Schrift2, Brushes.Black, 50, 140 + 20 * N)
    End Sub

    Private Sub DruckenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DruckenToolStripMenuItem.Click
        With PrintPreviewDialog1
            .Document = PrintDocument1
            If .ShowDialog = Windows.Forms.DialogResult.OK Then
                PrintDocument1.Print()
            End If
        End With
    End Sub

End Class
